/**************************************************************************

	ns

	func_io.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "script.h"
#include "script_memory.h"
#include "script_string.h"
#include "script_utility.h"
#ifdef _WIN32_WCE
#include "view.h"
#endif


/**************************************************************************
	Define
**************************************************************************/

/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	_sfunc_puts

	Wo͂ɕ

******************************************************************************/

int SFUNC _sfunc_puts(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
#ifdef _WIN32_WCE
	HWND hWnd;
	TCHAR *str;
	char *cstr;

	if(CheckEndEvent() == TRUE){
		return -1;
	}

	if(param == NULL){
		return -2;
	}
	hWnd = (HWND)ei->sci->param1;
	if(hWnd == NULL){
		return -1;
	}
	if(param->v->Type == TYPE_INTEGER){
		str = VariableToTString(param);
	}else{
		char *p, *r;
		int len = 0;

		for(p = param->v->u.Value; *p != '\0'; p++){
			if(*p == '\r'){
			}else if(*p == '\n'){
				len += 2;
			}else{
				len++;
			}
		}
		r = cstr = mem_alloc(sizeof(char) * (len + 1));
		if(cstr == NULL){
			return -1;
		}
		for(p = param->v->u.Value; *p != '\0'; p++){
			if(*p == '\r'){
			}else if(*p == '\n'){
				*(r++) = '\r';
				*(r++) = '\n';
			}else{
				*(r++) = *p;
			}
		}
		*r = '\0';
		str = char2tchar(cstr);
	}

	//o
	SendMessage(hWnd, WM_ADDTEXT, 0, (LPARAM)str);
	mem_free(&str);
#else	//_WIN32_WCE
	HANDLE ih;
	TCHAR *str;
	int size;

	if(param == NULL){
		return -2;
	}

	str = VariableToTString(param);

	ih = GetStdHandle(STD_OUTPUT_HANDLE);
	//Wo͂ɕo
	WriteConsole(ih, str, lstrlen(str), &size, NULL);

	mem_free(&str);
#endif	//_WIN32_WCE
	return 0;
}


/******************************************************************************

	_sfunc_gets

	W͂當ǂݎ

******************************************************************************/

int SFUNC _sfunc_gets(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
#ifdef _WIN32_WCE
	MSG msg;
	HWND hWnd;
	char *p;
	int len;

	if(CheckEndEvent() == TRUE){
		return -1;
	}
	hWnd = (HWND)ei->sci->param1;
	if(hWnd == NULL){
		return -1;
	}
	if(param == NULL){
		return -2;
	}
	len = VariableToInt(param);

	SendMessage(hWnd, WM_GETS, 0, GetCurrentThreadId());

	while(1){
		Sleep(10);
		if(CheckEndEvent() == TRUE){
			return -1;
		}
		PeekMessage(&msg, NULL, TH_GETS, TH_GETS, PM_REMOVE);
		if(msg.message == TH_GETS){
			break;
		}
	}
	p = ((TCHAR *)msg.lParam == NULL) ? alloc_copy("") : tchar2char((TCHAR *)msg.lParam);
	ret->v->u.Value = p;
	ret->v->Type = TYPE_STRING;
#else	//_WIN32_WCE
	HANDLE ih;
	TCHAR *p;
	char *cp;
	int len;
	int mode, rmode;
	int size;

	if(param == NULL){
		return -2;
	}

	len = VariableToInt(param);

	ih = GetStdHandle(STD_INPUT_HANDLE);
	//Wo͂̃[h擾
	GetConsoleMode(ih, &mode);
	rmode = mode;
	//s̓[hɐݒ
	mode |= ENABLE_LINE_INPUT;
	SetConsoleMode(ih, mode);
	p = mem_alloc(sizeof(TCHAR) * len + 2);
	//W͂當ǂݎ
	ReadConsole(ih, p, len + 1, &size, NULL);
	SetConsoleMode(ih, rmode);

#ifdef UNICODE
	ret->v->u.Value = tchar2char(p);
	mem_free(&p);
#else	//UNICODE
	ret->v->u.Value = p;
#endif	//UNICODE

	for(cp = ret->v->u.Value; *cp != '\0' && *cp != '\r' && *cp != '\n'; cp++);
	*cp = '\0';

	ret->v->Type = TYPE_STRING;
#endif	//_WIN32_WCE
	return 0;
}


/******************************************************************************

	_sfunc_getchar

	W͂當ǂݎ

******************************************************************************/

int SFUNC _sfunc_getchar(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
#ifdef _WIN32_WCE
	MSG msg;
	HWND hWnd;
	char *p;

	if(CheckEndEvent() == TRUE){
		return -1;
	}
	hWnd = (HWND)ei->sci->param1;
	if(hWnd == NULL){
		return -1;
	}
	SendMessage(hWnd, WM_GETCHAR, 0, GetCurrentThreadId());

	while(1){
		Sleep(1);
		if(CheckEndEvent() == TRUE){
			return -1;
		}
		PeekMessage(&msg, NULL, TH_GETCHAR, TH_GETCHAR, PM_REMOVE);
		if(msg.message == TH_GETCHAR && (TCHAR *)msg.lParam != NULL){
			break;
		}
	}
	p = tchar2char((TCHAR *)msg.lParam);
	ret->v->u.Value = p;
	ret->v->Type = TYPE_STRING;
#else	//_WIN32_WCE
	HANDLE ih;
	TCHAR buf[4];
	TCHAR *p;
	int mode, rmode;
	int size;

	ih = GetStdHandle(STD_INPUT_HANDLE);
	//Wo͂̃[h擾
	GetConsoleMode(ih, &mode);
	rmode = mode;
	//̓[hɐݒ
	mode &= ~ENABLE_LINE_INPUT;
	mode &= ~ENABLE_ECHO_INPUT;

	SetConsoleMode(ih, mode);
	//W͂當ǂݎ
	ReadConsole(ih, buf, 1, &size, NULL);
	SetConsoleMode(ih, rmode);

	if(*buf == TEXT('\n')){
		*buf = TEXT('\0');
	}else if(*buf == TEXT('\r')){
		*buf = TEXT('\n');
	}
#ifdef UNICODE
	p = mem_alloc(sizeof(TCHAR) * 2);
	*p = *buf;
	*(p + 1) = '\0';
#else	//UNICODE
	if(IsDBCSLeadByte(*buf) == TRUE && *(buf + 1) != '\0'){
		//2oCgR[h
		p = mem_alloc(sizeof(char) * 3);
		*p = *buf;
		*(p + 1) = *(buf + 1);
		*(p + 2) = '\0';
	}else{
		p = mem_alloc(sizeof(char) * 2);
		*p = *buf;
		*(p + 1) = '\0';
	}
#endif	//UNICODE
	if(rmode & ENABLE_ECHO_INPUT){
		//echo
		ih = GetStdHandle(STD_OUTPUT_HANDLE);
		WriteConsole(ih, p, lstrlen(p), &size, NULL);
	}

#ifdef UNICODE
	ret->v->u.Value = tchar2char(p);
#else	//UNICODE
	ret->v->u.Value = p;
#endif	//UNICODE
	ret->v->Type = TYPE_STRING;
#endif	//_WIN32_WCE
	return 0;
}


/******************************************************************************

	_sfunc_getecho

	W͂ECHOݒ

******************************************************************************/

int SFUNC _sfunc_setechomode(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
#ifdef _WIN32_WCE
	HWND hWnd;
	int f;

	if(CheckEndEvent() == TRUE){
		return -1;
	}
	hWnd = (HWND)ei->sci->param1;
	if(hWnd == NULL){
		return -1;
	}

	if(param == NULL){
		return -2;
	}
	f = VariableToInt(param);

	SendMessage(hWnd, WM_SETECHO, 0, (LPARAM)((f == 0) ? FALSE : TRUE));
#else	//_WIN32_WCE
	HANDLE ih;
	int f;
	int mode;

	if(param == NULL){
		return -2;
	}

	f = VariableToInt(param);

	ih = GetStdHandle(STD_INPUT_HANDLE);
	GetConsoleMode(ih, &mode);
	if(f == 0){
		mode &= ~ENABLE_ECHO_INPUT;
	}else{
		mode |= ENABLE_ECHO_INPUT;
	}
	SetConsoleMode(ih, mode);
#endif	//_WIN32_WCE
	return 0;
}
/* End of source */
