/**************************************************************************

	ns

	functbl.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "script.h"
#include "script_string.h"


/**************************************************************************
	Function Prototypes
**************************************************************************/

//func_error.c
int SFUNC _sfunc_error(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);

//func_std.c
int SFUNC _sfunc_istype(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_int(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_uintstr(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getlocale(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_setlocale(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_sleep(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);

//func_time.c
int SFUNC _sfunc_getsystemtime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_setsystemtime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getlocaltime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_setlocaltime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_comparetime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_difftime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getdatestring(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getdate(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_gettimestring(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_gettime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);

//func_string.c
int SFUNC _sfunc_chr(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_asc(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_string(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_trim(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_len(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_strcmp(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_strmatch(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_left(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_right(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_mid(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_instr(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_tolower(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_toupper(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);

//func_hash.c
int SFUNC _sfunc_gethashcount(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_sethashcount(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_gethashkey(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_sethashkey(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_ishashkey(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_hashinsert(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_hashdelete(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_hashfind(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_hashkeysort(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_hashsort(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_hashcopy(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_hashmerge(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_hashtostring(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_stringtohash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);

//func_rege.c
int SFUNC _sfunc_regmatch(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_regmatchall(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_regreplace(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);

//func_code.c
int SFUNC _sfunc_isleadchar(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getcodetype(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_sjistojis(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_jistosjis(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_sjistoeuc(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_euctosjis(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_hashtosjis(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_base64decode(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_base64decodehash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_base64encode(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_base64encodehash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);

//func_file.c
int SFUNC _sfunc_createdirectory(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_removedirectory(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getcurrentdirectory(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_setcurrentdirectory(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_copyfile(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_movefile(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_deletefile(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_fileopen(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_fileclose(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getfilesize(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_setfilepointer(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_fileread(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_filereadhash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_filewrite(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_filewritehash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_filefindinit(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_filefindnext(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_filefindclose(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_filefindattributes(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_filefindname(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_filefindsize(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_filefindtime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_shell(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_execscript(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);

//func_sock.c
int SFUNC _sfunc_gethostname(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_gethostbyname(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_gethostbyaddr(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getsockname(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getpeername(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getsockport(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_socket(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_closesocket(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_connect(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_bind(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_listen(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_accept(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_select(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_recv(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_recvhash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_send(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_sendhash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);

//func_io.c
int SFUNC _sfunc_puts(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_gets(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getchar(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_setechomode(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_setechomode(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);


/**************************************************************************
	Global Variables
**************************************************************************/

typedef struct _FUNCTBL {
	char *name;
	int name_hash;
	LIBFUNC func;
} FUNCTBL;

FUNCTBL ft[] = {
	"_sfunc_error", 0, _sfunc_error,

	"_sfunc_istype", 0, _sfunc_istype,
	"_sfunc_int", 0, _sfunc_int,
	"_sfunc_uintstr", 0, _sfunc_uintstr,
	"_sfunc_getlocale", 0, _sfunc_getlocale,
	"_sfunc_setlocale", 0, _sfunc_setlocale,
	"_sfunc_sleep", 0, _sfunc_sleep,

	"_sfunc_getsystemtime", 0, _sfunc_getsystemtime,
	"_sfunc_setsystemtime", 0, _sfunc_setsystemtime,
	"_sfunc_getlocaltime", 0, _sfunc_getlocaltime,
	"_sfunc_setlocaltime", 0, _sfunc_setlocaltime,
	"_sfunc_comparetime", 0, _sfunc_comparetime,
	"_sfunc_difftime", 0, _sfunc_difftime,
	"_sfunc_getdatestring", 0, _sfunc_getdatestring,
	"_sfunc_getdate", 0, _sfunc_getdate,
	"_sfunc_gettimestring", 0, _sfunc_gettimestring,
	"_sfunc_gettime", 0, _sfunc_gettime,

	"_sfunc_chr", 0, _sfunc_chr,
	"_sfunc_asc", 0, _sfunc_asc,
	"_sfunc_string", 0, _sfunc_string,
	"_sfunc_trim", 0, _sfunc_trim,
	"_sfunc_len", 0, _sfunc_len,
	"_sfunc_left", 0, _sfunc_left,
	"_sfunc_strcmp", 0, _sfunc_strcmp,
	"_sfunc_strmatch", 0, _sfunc_strmatch,
	"_sfunc_right", 0, _sfunc_right,
	"_sfunc_mid", 0, _sfunc_mid,
	"_sfunc_instr", 0, _sfunc_instr,
	"_sfunc_tolower", 0, _sfunc_tolower,
	"_sfunc_toupper", 0, _sfunc_toupper,

	"_sfunc_gethashcount", 0, _sfunc_gethashcount,
	"_sfunc_sethashcount", 0, _sfunc_sethashcount,
	"_sfunc_gethashkey", 0, _sfunc_gethashkey,
	"_sfunc_sethashkey", 0, _sfunc_sethashkey,
	"_sfunc_ishashkey", 0, _sfunc_ishashkey,
	"_sfunc_hashinsert", 0, _sfunc_hashinsert,
	"_sfunc_hashdelete", 0, _sfunc_hashdelete,
	"_sfunc_hashfind", 0, _sfunc_hashfind,
	"_sfunc_hashkeysort", 0, _sfunc_hashkeysort,
	"_sfunc_hashsort", 0, _sfunc_hashsort,
	"_sfunc_hashcopy", 0, _sfunc_hashcopy,
	"_sfunc_hashmerge", 0, _sfunc_hashmerge,
	"_sfunc_hashtostring", 0, _sfunc_hashtostring,
	"_sfunc_stringtohash", 0, _sfunc_stringtohash,

	"_sfunc_regmatch", 0, _sfunc_regmatch,
	"_sfunc_regmatchall", 0, _sfunc_regmatchall,
	"_sfunc_regreplace", 0, _sfunc_regreplace,

	"_sfunc_isleadchar", 0, _sfunc_isleadchar,
	"_sfunc_getcodetype", 0, _sfunc_getcodetype,
	"_sfunc_sjistojis", 0, _sfunc_sjistojis,
	"_sfunc_jistosjis", 0, _sfunc_jistosjis,
	"_sfunc_sjistoeuc", 0, _sfunc_sjistoeuc,
	"_sfunc_euctosjis", 0, _sfunc_euctosjis,
	"_sfunc_hashtosjis", 0, _sfunc_hashtosjis,
	"_sfunc_base64decode", 0, _sfunc_base64decode,
	"_sfunc_base64decodehash", 0, _sfunc_base64decodehash,
	"_sfunc_base64encode", 0, _sfunc_base64encode,
	"_sfunc_base64encodehash", 0, _sfunc_base64encodehash,

	"_sfunc_createdirectory", 0, _sfunc_createdirectory,
	"_sfunc_removedirectory", 0, _sfunc_removedirectory,
	"_sfunc_getcurrentdirectory", 0, _sfunc_getcurrentdirectory,
	"_sfunc_setcurrentdirectory", 0, _sfunc_setcurrentdirectory,
	"_sfunc_copyfile", 0, _sfunc_copyfile,
	"_sfunc_movefile", 0, _sfunc_movefile,
	"_sfunc_deletefile", 0, _sfunc_deletefile,
	"_sfunc_fileopen", 0, _sfunc_fileopen,
	"_sfunc_fileclose", 0, _sfunc_fileclose,
	"_sfunc_getfilesize", 0, _sfunc_getfilesize,
	"_sfunc_setfilepointer", 0, _sfunc_setfilepointer,
	"_sfunc_fileread", 0, _sfunc_fileread,
	"_sfunc_filereadhash", 0, _sfunc_filereadhash,
	"_sfunc_filewrite", 0, _sfunc_filewrite,
	"_sfunc_filewritehash", 0, _sfunc_filewritehash,
	"_sfunc_filefindinit", 0, _sfunc_filefindinit,
	"_sfunc_filefindnext", 0, _sfunc_filefindnext,
	"_sfunc_filefindclose", 0, _sfunc_filefindclose,
	"_sfunc_filefindattributes", 0, _sfunc_filefindattributes,
	"_sfunc_filefindname", 0, _sfunc_filefindname,
	"_sfunc_filefindsize", 0, _sfunc_filefindsize,
	"_sfunc_filefindtime", 0, _sfunc_filefindtime,
	"_sfunc_shell", 0, _sfunc_shell,
	"_sfunc_execscript", 0, _sfunc_execscript,

	"_sfunc_gethostname", 0, _sfunc_gethostname,
	"_sfunc_gethostbyname", 0, _sfunc_gethostbyname,
	"_sfunc_gethostbyaddr", 0, _sfunc_gethostbyaddr,
	"_sfunc_getsockname", 0, _sfunc_getsockname,
	"_sfunc_getpeername", 0, _sfunc_getpeername,
	"_sfunc_getsockport", 0, _sfunc_getsockport,
	"_sfunc_socket", 0, _sfunc_socket,
	"_sfunc_closesocket", 0, _sfunc_closesocket,
	"_sfunc_connect", 0, _sfunc_connect,
	"_sfunc_bind", 0, _sfunc_bind,
	"_sfunc_listen", 0, _sfunc_listen,
	"_sfunc_accept", 0, _sfunc_accept,
	"_sfunc_select", 0, _sfunc_select,
	"_sfunc_recv", 0, _sfunc_recv,
	"_sfunc_recvhash", 0, _sfunc_recvhash,
	"_sfunc_send", 0, _sfunc_send,
	"_sfunc_sendhash", 0, _sfunc_sendhash,

	"_sfunc_puts", 0, _sfunc_puts,
	"_sfunc_gets", 0, _sfunc_gets,
	"_sfunc_getchar", 0, _sfunc_getchar,
	"_sfunc_setechomode", 0, _sfunc_setechomode,
};


/******************************************************************************

	InitFuncAddress

	֐e[ȕ

******************************************************************************/

void InitFuncAddress()
{
	int i;

	for(i = 0; i < sizeof(ft) / sizeof(FUNCTBL); i++){
		(ft + i)->name_hash = str2hash((ft + i)->name);
	}
}


/******************************************************************************

	GetFuncAddress

	֐AhX擾

******************************************************************************/

LIBFUNC GetFuncAddress(char *FuncName)
{
	int name_hash;
	int i;

	name_hash = str2hash(FuncName);
	for(i = 0; i < sizeof(ft) / sizeof(FUNCTBL); i++){
		if((ft + i)->name_hash == name_hash && tstrcmp((ft + i)->name, FuncName) == 0){
			return (ft + i)->func;
		}
	}
	return NULL;
}
/* End of source */
