/**************************************************************************

	ns

	script_string.h

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

#ifndef SCRIPT_STRING_H
#define SCRIPT_STRING_H

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>


/**************************************************************************
	Define
**************************************************************************/

#ifdef UNICODE
#define tstrcpy				strcpy
#else
#define tstrcpy				lstrcpy
#endif

#ifdef UNICODE
#define tstrcpyn			strncpy
#else
#define tstrcpyn			lstrcpyn
#endif

#ifdef UNICODE
#define tstrcat				strcat
#else
#define tstrcat				lstrcat
#endif

#ifdef UNICODE
#define tstrcmp				strcmp
#else
#define tstrcmp				lstrcmp
#endif

#ifdef UNICODE
#define tstrlen				strlen
#else
#define tstrlen				lstrlen
#endif


/**************************************************************************
	Struct
**************************************************************************/

/**************************************************************************
	Function Prototypes
**************************************************************************/

char *tchar2char(const TCHAR *str);
TCHAR *char2tchar(const char *str);
char *str_cpy(char *ret, const char *buf);
char *str_cpy_n(char *ret, char *buf, const int len);
int str_cmp_n(const char *buf1, const char *buf2, const int len);
int str_cmp_i(const char *buf1, const char *buf2);
int str_cmp_ni(const char *buf1, const char *buf2, const int len);
BOOL str_match(const char *Ptn, const char *Str);
char *i2a(long i);
long x2d(const char *str);
long o2d(const char *str);
BOOL conv_ctrl(char *buf);
char *reconv_ctrl(char *buf);
char *str_skip(char *p);
char *get_pair_brace(char *buf);
BOOL str_trim(char *buf);
void str_lower(char *p);
int str2hash(char *str);

#endif
/* End of source */
